/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.TypeDataObjek;
import com.portofolio.entity.vo.TypeDataObjekId;

import java.util.List;
import java.util.Map;

@Lazy
@Repository
public interface TypeDataObjekDao extends CrudRepository<TypeDataObjek, TypeDataObjekId> {

    @Cacheable("TypeDataObjekDaofindOneBy")
    TypeDataObjek findOneByKode(Integer kode);
    

    @Query(QListAll)
    @Cacheable("TypeDataObjekDaoFindAllList")
    Page<Map<String, Object>> findAllList( Pageable page );
    
    @Query(QListAll + " and model.namaTypeDataObjek like %:namaTypeDataObjek% ")
    @Cacheable("TypeDataObjekDaoFindAllListPage")
    Page<Map<String, Object>> findAllList( @Param("namaTypeDataObjek") String namaTypeDataObjek, Pageable page );
    
    @Query(QListAll + " and model.kode =:kode")
    @Cacheable("TypeDataObjekDaoFindByKode")
    Map<String, Object> findByKode( @Param("kode") Integer kode );

    @Cacheable("TypeDataObjekDaofindAllCombo")
    @Query("select new map(model.kode as kode , model.namaTypeDataObjek as namaTypeDataObjek ) " +
            "  from TypeDataObjek model where model.statusEnabled=true")
    List<Map<String,Object>> findAllCombo();
    
    String QListAll ="select new map(model.kdTypeDataObjek as kdTypeDataObjek "
            + ", model.namaTypeDataObjek as namaTypeDataObjek "
            + ", model.reportDisplay as reportDisplay " 
            + ", model.rangeNilaiAwal as rangeNilaiAwal "
            + ", model.rangeNilaiAkhir as rangeNilaiAkhir "
            + ", model.lengthPrecision as lengthPrecision "
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec "
            + ", model.storageBytesSize as storageBytesSize "
            + ", model.kdTypeDataObjekHead as kdTypeDataObjekHead  "
            + ", model.databaseVersion as databaseVersion "
            + " ,model.version as version," +
            " typeDataObjekHead.namaTypeDataObjek as namaTypeDataObjekHead )"
            + " from TypeDataObjek model left join model.typeDataObjekHead typeDataObjekHead where  1=1 ";

}
